image: python:3.10

variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

cache:
  paths:
    - .cache/pip
    - venv/

stages:
  - test
  - deploy

tests:
  stage: test
  interruptible: true
  coverage: '/^TOTAL.*\s+(\d+\%)$/'
  before_script:
    - python -V
    - pip install virtualenv
    - virtualenv venv
    - source venv/bin/activate
    - pip install tox
  script:
    - tox

pypi:
  stage: deploy
  script:
    - pip install -U twine
    - python setup.py sdist
    - twine upload dist/*
  only:
    - tags
